SystemOrganization addCategory: #'JiffyCard-Test'!

TestCase subclass: #JCPGraphTest
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCPGraphTest methodsFor: 'as yet unclassified' stamp: 'chc 12/25/2017 08:46'!
setUp
	root := JCRoot new.
	! !

!JCPGraphTest methodsFor: 'as yet unclassified' stamp: 'chc 12/25/2017 08:50'!
testHash
	"Test hash is the same after serialization for one object in two places in the graph"
	|after|
	after := root serialize materialize.
	self assert: after leaf passenger hash = after node leaf passenger hash! !

TestCase subclass: #JCPassIvarTest
	instanceVariableNames: 'dummy1 dummy2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCPassIvarTest commentStamp: 'chc 12/23/2017 11:33' prior: 0!
Create an object with an ivar. Serialize. Pass it to another object!

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:40'!
setUp
	dummy1 := JCDummyOne new serialize! !

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 12:45'!
testHashChanged
	| hashstart hashfinish |
	hashstart := dummy1 hash.
	hashfinish :=  (dummy1 serialize materialize) hash.
	self assert: hashstart ~= hashfinish! !

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:50'!
testInitialDummyHasItems
	self assert: (dummy1 materialize) cart hasItems! !

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:40'!
testMaterializeIvar
	self assert: (dummy1 materialize) cart notNil! !

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:51'!
testNextDummyHasItems
	| dummy2 |
	dummy2 := JCDummyTwo new cart: (dummy1 materialize) cart.
	self assert: (dummy2 serialize materialize) cart hasItems! !

!JCPassIvarTest methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:46'!
testPassIvar
	| dummy2 |
	dummy2 := JCDummyTwo new cart: (dummy1 materialize) cart.
	self assert: (dummy2 serialize materialize) cart notNil! !

Object subclass: #JCLeaf
	instanceVariableNames: 'passenger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCLeaf methodsFor: 'as yet unclassified' stamp: 'chc 12/25/2017 08:03'!
initialize
	passenger := JCPassenger new! !

!JCLeaf methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:27'!
passenger

	^ passenger! !

!JCLeaf methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:27'!
passenger: anObject

	passenger := anObject! !

Object subclass: #JCNode
	instanceVariableNames: 'leaf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCNode methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
leaf

	^ leaf! !

!JCNode methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
leaf: anObject

	leaf := anObject! !

Object subclass: #JCPassenger
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCPassenger methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:02'!
addOne 
	count := count + 1! !

!JCPassenger methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:01'!
count

	^ count! !

!JCPassenger methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:01'!
count: anObject

	count := anObject! !

!JCPassenger methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:05'!
initialize
	count := 0! !

Object subclass: #JCRoot
	instanceVariableNames: 'leaf node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCRoot methodsFor: 'as yet unclassified' stamp: 'chc 12/25/2017 08:01'!
initialize
	leaf := JCLeaf new.
	node := JCNode new leaf: leaf! !

!JCRoot methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
leaf

	^ leaf! !

!JCRoot methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
leaf: anObject

	leaf := anObject! !

!JCRoot methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
node

	^ node! !

!JCRoot methodsFor: 'accessing' stamp: 'chc 12/25/2017 08:00'!
node: anObject

	node := anObject! !

JCCard subclass: #JCDummyOne
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCDummyOne methodsFor: 'accessing' stamp: 'chc 12/23/2017 11:32'!
cart

	^ cart! !

!JCDummyOne methodsFor: 'accessing' stamp: 'chc 12/23/2017 11:32'!
cart: anObject

	cart := anObject! !

!JCDummyOne methodsFor: 'as yet unclassified' stamp: 'chc 12/23/2017 11:47'!
initialize
	cart := WAStoreCart new add: (WAStoreItem new title: 'Kisu')! !

JCCard subclass: #JCDummyTwo
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Test'!

!JCDummyTwo methodsFor: 'accessing' stamp: 'chc 12/23/2017 11:32'!
cart

	^ cart! !

!JCDummyTwo methodsFor: 'accessing' stamp: 'chc 12/23/2017 11:32'!
cart: anObject

	cart := anObject! !
